//+------------------------------------------------------------------+
//|                                                                  |
//|                 Copyright c 1999-2006, MetaQuotes Software Corp. |
//|                                         http://www.metaquotes.ru |
//|                                                                  |
//|                                                YZMSSQLSample.mq4 |
//|                                                                  |
//|                                                   Yuriy Zaitsev  |
//+------------------------------------------------------------------+
//    MS SQL                                        |
//+------------------------------------------------------------------+

#property copyright "YURAZ Copyright(C) 2008"
#property link      "yz@mail.ru"



//   MT4  MS SQL 2000
//  
//             .
//      ,    
//
//           MS SQL    
//               
//     .         
// 
//             EXCEL , 
//        
//  
//         HISTORY  ,      MT4
//         , 
//       MT4 ->->     5000
//              
// 
//          MS SQL,  STATISTICA-7,8 
//      SQL         MT4
//
//             
//  SQL SERVER,          .
//
//
//
//       
//
//    MS SQL SERVER 2000 Developer     - 
//    VISUAL C++ 6.0  SP5              -   DLL "YZMSSQLExpertSample.dll"
//    MDAC 7                           - 
//
//

//+------------------------------------------------------------------+
//        MS SQL
//+------------------------------------------------------------------+


/*


-----------------------------------------------------------------------
------------------  --------------------------------------
-----------------------------------------------------------------------
---
---       
---
-----------------------------------------------------------------------


--- 
---   ,    ... 
---
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[BSIGNAL]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[BSIGNAL]
GO

CREATE TABLE [dbo].[BSIGNAL] (
	[SignalDateTime] [datetime] NULL ,
	[SIGNAL] [int] NULL ,
	[TP] [decimal](18, 4) NULL ,
	[SL] [decimal](18, 4) NULL ,
	[TRAL] [decimal](18, 4) NULL ,
	[SYMBOL] [char] (6) COLLATE SQL_Latin1_General_CP1251_CI_AS NULL 
	[FlagSignal] [int] NULL ,
) ON [PRIMARY]
GO
--
--   BSIGNAL 
--
-- 
--	SignalDateTime -     
-- 	SIGNAL         -    int 
--                 
--                          0  OP_BUY          
--                          1  OP_SELL         
--                          2  OP_BUYLIMIT      BUY LIMIT 
--                          3  OP_SELLLIMIT     SELL LIMIT 
--                          4  OP_BUYSTOP       BUY STOP 
--                          5  OP_SELLSTOP      SELL STOP 
--                 
--                 
--                          50-BUY_CLOSE            BUY
--                          51-SELL_CLOSE           SELL
--                          52-DEL_BUYLIMIT        
--                          53-DEL_SELLLIMIT      
--                          54-DEL_BUYSTOP
--                          55-DEL_SELLSTOP
--                 
--                                            
-- 	TP             -  
-- 	SL             -  
-- 	TRAL           -    
-- 	SYMBOL         - 
--      FlagSignal     -  0  -   
--                        1  -    MT4 (      MT4 )
--                       -1  -  
--
--       ,       
-- 



--
--    
--

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MT4TICK]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[MT4TICK]
GO

CREATE TABLE [dbo].[MT4TICK] (
	[idc] [bigint] IDENTITY (1, 1) NOT NULL ,
	[ServerDateTime] [datetime] NULL ,
	[iDateTime] [bigint] NULL ,
	[sSymbol] [char] (6) COLLATE SQL_Latin1_General_CP1251_CI_AS NULL ,
	[cAsk] [numeric](18, 4) NULL ,
	[cBid] [numeric](18, 4) NULL 
) ON [PRIMARY]
GO

--            ,    ServerDateTime ---
ALTER TABLE [dbo].[MT4TICK] ADD 
	CONSTRAINT [DF_MT4TICK_ServerDateTime] DEFAULT (getdate()) FOR [ServerDateTime]
GO


---
---
---      
---            
---      MS SQL        
---           
---
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MT4C]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[MT4C]
GO

CREATE TABLE [dbo].[MT4C] (
	[cid] [bigint] IDENTITY (1, 1) NOT NULL ,
	[ServerDateTime] [datetime] NULL ,
	[cDateTime] [bigint] NULL ,
	[sSymbol] [char] (6) COLLATE SQL_Latin1_General_CP1251_CI_AS NULL ,
	[cOpen] [float] NULL ,
	[cHigh] [float] NULL ,
	[cLow] [float] NULL ,
	[cClose] [float] NULL ,
	[cVolume] [float] NULL ,
	[cAsk] [numeric](18, 4) NULL ,
	[cBid] [numeric](18, 4) NULL 
) ON [PRIMARY]
GO

--            ,      ServerDateTime ---
ALTER TABLE [dbo].[MT4C] ADD 
	CONSTRAINT [DF_MT4C_ServerDateTime] DEFAULT (getdate()) FOR [ServerDateTime]
GO




---
---
---
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[YZ_MT4_SIGNAL]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure  dbo.YZ_MT4_SIGNAL
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE  dbo.YZ_MT4_SIGNAL
   @psSymbol char (6)
  , @P1  int    out

AS
select @P1 = SIGNAL  from  BSIGNAL where SYMBOL = @psSymbol
return @P1
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

------------------------------------------------------------------

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[YZ_MT4_T1]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.YZ_MT4_T1
GO

CREATE PROCEDURE dbo.YZ_MT4_T1
  @P1  int    out
AS
declare @RET1 int  
select @RET1 = 333
select @P1 = @RET1
return @P1
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[YZ_MT4_TICK]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.YZ_MT4_TICK
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE dbo.YZ_MT4_TICK
    @RetCode int out
   ,@psSymbol char(6)
   ,@piDateTime  bigint
   ,@pdAsk  float
   ,@pdBid  float
AS
insert into  MT4TICK   ( sSymbol, iDateTime, cAsk, cBid   )  values  ( @psSymbol , @piDateTime,  @pdAsk ,  @pdBid  )
select @RetCode=0
return @RetCode
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[YZ_MT4_HISTORY]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[YZ_MT4_HISTORY]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MT4HISTORY]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[MT4HISTORY]
GO

CREATE TABLE [dbo].[MT4HISTORY] (
	[cid] [bigint] IDENTITY (1, 1) NOT NULL ,
	[ServerDateTime] [datetime] NULL ,
	[iTimeFrame] [int] NULL ,
	[sSymbol] [char] (6) COLLATE SQL_Latin1_General_CP1251_CI_AS NULL ,
	[iDateTime] [bigint] NULL ,
	[cOpen] [numeric](18, 4) NULL ,
	[cHigh] [numeric](18, 4) NULL ,
	[cLow] [numeric](18, 4) NULL ,
	[cClose] [numeric](18, 4) NULL ,
	[cVolume] [numeric](18, 4) NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[MT4HISTORY] ADD 
	CONSTRAINT [DF_MT4C_ServerDateTime] DEFAULT (getdate()) FOR [ServerDateTime]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE dbo.YZ_MT4_HISTORY
    @RetCode int out
   ,@piTimeFrame  int
   ,@psSymbol char(6)
   ,@piDateTime  bigint
   ,@pdOpen  float
   ,@pdHigh   float
   ,@pdLow   float
   ,@pdClose float
   ,@pdVolume  float

AS
insert into  MT4HISTORY   ( iTimeFrame     , sSymbol       , iDateTime      , cOpen       , cHigh      , cLow     , cClose      , cVolume      ) 
                               values  ( @piTimeFrame, @psSymbol , @piDateTime,  @pdOpen , @pdHigh,@pdLow, @pdClose ,@pdVolume )
select @RetCode=0
return @RetCode
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


--- select * from MT4TICK order by idc


-----------------------------------------------------------------------
------------------    -------------------------------------
-----------------------------------------------------------------------

*/






//+------------------------------------------------------------------+
//   DLL 
//+------------------------------------------------------------------+
#import "YZMSSQLExpertSample.dll"
//+------------------------------------------------------------------+
//
//      MS SQL 
//
//  int Ret = SQLTickPut(  Symbol(), TimeCurrent() , Ask, Bid  );
//
//      
//
//      char(6)      
//      datetime     TIME 
//      double       Ask
//      double       Bid
//
//    0 -  
//
//+------------------------------------------------------------------+
int SQLProcedureTickPut( string,  int , double , double ,string );  
//+------------------------------------------------------------------+
//
//     INT           
//
//      -   
//     int
//
//+------------------------------------------------------------------+
int SQLProcedureGetInt( string );                  
//+------------------------------------------------------------------+
//
//     INT           
//
//  SQLProcedureGetSignal (Symbol() , "YZ_MT4_SIGNAL" )
//
//      
//     -  
//     -   
//
//     int 
//
//   0 - OP_BUY  
//   1 - OP_SELL
//   2 - OP_CLOSE
//
//+------------------------------------------------------------------+
int SQLProcedureGetSignal(string, string);
//+------------------------------------------------------------------+


int Prc = 0;
int init()
  {

//
// SQLProcedureGetInt     , 
//   MT4 int    
//   MS SQL  ,    
//
//
   Prc =     SQLProcedureGetInt ("YZ_MT4_T1"); 
   Print( " Prc >>> "+Prc);
   return(0);
  }

int start()
  {
   int a;

   int RetCode = SQLProcedureTickPut( Symbol(), TimeCurrent() , Ask, Bid ,"YZ_MT4_TICK"); //    
   Print(" SQLProcedureTickPut (YZ_MT4_NEWDAY)"+ RetCode );


//   RetCode= SQLProcedureGetInt ("YZ_MT4_NEWDAY"); //  MS SQL ,         
//   Print(" SQLProcedureGetInt (YZ_MT4_NEWDAY)"+ RetCode );
// 
//   MS SQL          
//      
//       
//
/*
   int Signal = SQLProcedureGetSignal (Symbol() , "YZ_MT4_SIGNAL" ); //  MS SQL ,  
   Print(" SQLProcedureGetSignal (Symbol() , YZ_MT4_SIGNAL )"+ Signal );
   if ( Signal == OP_BUY )
   {
       //   ,   
   }
   if ( Signal == OP_SELL )
   {
       //   ,   
   }
*/

   return(0);
  }



